clc
clear

%defino valores base
Ubp=150;
Ubs=31.50;
Ubt=6.3;
Sb=120;
Zbp=Ubp^2/Sb
Zbs=Ubs^2/Sb
Zbt=Ubt^2/Sb

%linea 2
ZL2=0.1+0.5*j; % (?)
zl2=ZL2/Zbs

%trafo 150/31.5/6.3 kV 120/120/60 MVA
% xps=11.82% xst=26.57% xpt=12.3% en base 120/120/60 MVA respectivamente
xps=0.1182; % base 120
xst=0.2657; % base 120
xpt=0.184*120/60 % cambio de base a 120

xp=j*((xps+xpt-xst)/2)  
xs=j*((xps+xst-xpt)/2)  
xt=j*((xpt+xst-xps)/2)  

Z1=1+1*j; %(?)
Z2=20+10*j; %(?)
z1=Z1/Zbt
z2=Z2/Zbs

UB=30;% kV
ub=UB/Ubs

sb=ub^2/conj(z2)

%primer cuadripolo en Xs+ZL2
% defino un cuadripolo entre 0 y B
z=xs+zl2;

%formulas complejas
u0 = ub + z*conj(sb)/ub;
s0s = sb + z/ub^2*abs(sb)^2 %potencia del lado secundario

mu0 = abs(u0) 

s0t=mu0^2/conj(xt+z1)
s0p=s0s+s0t

%cuadripolo de la lnea
lw=0.327; %ohm/km
c=0.016e-6; %F/km
w=2*pi*50;
z=lw*j;%ohm/km
y=c*w*j;%ohm-1/km
L=240; %km
Z=z*L; %ohm
Y=y*L; %ohm
teta=sqrt(Z*Y);

A1=cosh(teta);
B1=Z*sinh(teta)/teta/Zbp;

% le agrego XP
A=A1           
B=B1+A1*xp    

ua=A*mu0+B*conj(s0p)/mu0
abs(ua)
abs(ua)*Ubp